/* *************************************************

Algorithm LB-treedec
input  A graph G =(V,E)
output A clique tree T of G

**************************************************** */

#include <LEDA/graph/graph.h>
#include <LEDA/graph/node_array.h>
#include <LEDA/core/slist.h>
#include <LEDA/core/list.h>
#include <LEDA/core/array.h>
#include <LEDA/core/string.h>
#include <LEDA/graphics/graphwin.h>
#include <iostream>
using namespace leda;
using namespace std;

void tree(graph &G,GRAPH<list<node>,int> &T);
void ope(graph &G,GRAPH<list<node>,int> &T,node v);
void c_component(graph &G,node_array<int> &node_ord);
void N_G(graph &G);
int existU_A();
void existX(graph &G,GRAPH<list<node>,int> &T,list<node> &X);
void replace(graph &G,GRAPH<list<node>,int> &T,node v);
void rep(GRAPH<list<node>,int> &T,list<node> &X_1,list<node> &X_2,node v);
void f_edge(GRAPH<list<node>,int> &T,list<node> &kl,node v);

list< list<node> > U_A; //U_A:minimal separator
list<node> C,L,S;       //C:C_G(N_H[v])  L:C in C_G S:N_G(C)

int main()
{
   cout << "(main)" << endl;
  graph G;
  G.read("graph7.gw");
  GRAPH<list<node>,int> T;
  G.make_undirected();
  T.make_undirected();

  node v;
  cout << "(graph G,nodes)" << endl;
  forall_nodes(v,G)
    cout << v << endl;
  cout << "(graph T,nodes)" << endl;
  forall_nodes(v,T) 
    cout << v << endl;
  tree(G,T);

  node w;
  cout << "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" << endl;
  forall_nodes(w,T){
    cout << T[w] << endl;
    forall(v,T[w])
      cout << v << " " ;
    cout << endl << endl;
  }

  T.write("out.gw");
}

void tree(graph &G,GRAPH<list<node>,int> &T)
{
   cout << "(tree)" << endl;
  U_A.clear();
  node w = T.new_node();
  node v;
  forall_nodes(v,G)
    T[w].append(v);
  forall_nodes(v,G){
    //  cout << "#################################" << endl;
    ope(G,T,v);
    // GraphWin gw(T,"LEDA Graph Editor");
    // gw.display(window::center,window::center);
    // gw.edit();
     node v,w;
     //   forall_nodes(v,T){
     //  forall(w,T[v])
     //	 cout << w << endl;
     // cout << "************* " << endl;
     // }
  }
}
void ope(graph &G,GRAPH<list<node>,int> &T,node v)
{
   cout << "(ope)#################################" << endl;
  C.clear();
  L.clear();
  S.clear();

  //N_H[i]
  node_array<int> C_G(G,1);
  node w;
  forall_adj_nodes(w,v)
    C_G[w]=0;
  list_item it,its;
  forall_items(it,U_A)
    if(U_A[it].search(v) != nil)
      forall_items(its,U_A[it])
	C_G[ U_A[it][its] ] = 0;
  C_G[v]=0;
  //cout << "(3) node_array C_G " ;   /*check*/
  //C_G.print(cout, '\n');  /*check*/
  //cout << endl;  /*check*/
  cout << "(3) list U_A " ;   /*check*/
   U_A.print(cout, '\n');  /*check*/
   cout << endl;  /*check*/

  //C_G(N_H[i])$B$r(Blist C$B$KJ]B8$9$k(B
  forall_nodes(w,G)
    if(C_G[w]==1)
      C.append(w);
  while( !C.empty() ){
    c_component(G,C_G);
    cout << "(3) list L " ;   /*check*/
    L.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/
    cout << "(3) list C " ;   /*check*/
    C.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/ 

    //S$B$N99?7(B:N_G(C)$B$r(BS$B$KJ]B8$9$k(B
    N_G(G);

    cout << "(3) list S " ;   /*check*/
    S.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    //U_A$B$N99?7(B
    if(!existU_A()){
      U_A.append(S);
      cout << "(3) list U_A " ;   /*check*/
      U_A.print(cout, '\n');  /*check*/
      cout << endl;  /*check*/
    }

    cout << "(3) list S " ;   /*check*/
    S.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    // bag X in T containing v and S and C

    list<node> X;;
    cout << "(3)-0 list X " ;   /*check*/
    X.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    forall(w,S)
      X.append(w);
    cout << "(3)-1 list X " ;   /*check*/
    X.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    if(X.search(v) == nil)
      X.append(v);
    cout << "(3)-2 list X " ;   /*check*/
    X.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    forall(w,L)
      if(X.search(w) == nil)
	X.append(w);
    cout << "(3)-3 list X " ;   /*check*/
    X.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/

    //X$B$rH=Dj(B
    existX(G,T,X);

    cout << "(3)-4 list X " ;   /*check*/
    X.print(cout, '\n');  /*check*/
    cout << endl;  /*check*/
  }

}

//connected component C in C_G(N_H[i])
void c_component(graph &G,node_array<int> &node_ord)
{
   cout << "(c_componet)" << endl;
  list_item it = C.first();

  node v = C[it];
  node_ord[v] = 0;
  L.append(v);
  C.erase(it);

  node w;
  forall_adj_nodes(w,v)
    if( node_ord[w]==1 )
      c_component(G,node_ord);
}


//N_G(C)$B$r(BS$B$KJ]B8$9$k(B
void N_G(graph &G)
{
  cout << "(N_G(C))" << endl;
  node v,w;
  forall(v,L){
    forall_adj_nodes(w,v){
      if(S.search(w)==nil)
	S.append(w);
      //    cout << "(5)-0 list S " ;   /*check*/
      //S.print(cout, '\n');  /*check*/
      //cout << endl;  /*check*/
    }
  }
  cout << "(5)-1 list S " ;   /*check*/
  S.print(cout, '\n');  /*check*/
  cout << endl;  /*check*/
  forall(v,L)
    S.remove(v);
}


int existU_A()
{
   cout << "(existU_A)" << endl;
   list_item S_it = S.first();  
  list_item U_it = U_A.first(); 
 
  list<node> K;
  node v;
  forall(K,U_A){
    int i=0;
    forall(v,S)
      if(K.search(v) != nil)
	i++;
    if(i==S.size()){
      cout << "(6)  int i " << endl;  /*check*/
      cout << i << endl;  /*check*/
      return 1;
    }
  }
   cout << "(6) list K " ;   /*check*/
   K.print(cout, '\n');  /*check*/
   cout << endl;  /*check*/
  return 0;
}

void existX(graph &G,GRAPH<list<node>,int> &T,list<node> &X)
{
   cout << "(existX)" << endl;
  node v,w;
  forall_nodes(v,T){
    int i=0;
    forall(w,X)
      if(T[v].search(w) != nil){
	i++;
	cout << "(7)  T[w] " << endl;  /*check*/
	cout << T[v] << endl;
      }
    if(i==X.size()){
      cout << "(7)  int i " << endl;  /*check*/
      cout << i << endl;  /*check*/

      //X_1,X_2$B:n@.(B
      replace(G,T,v);
    }
  }
}


void replace(graph &G,GRAPH<list<node>,int> &T,node v)
{
   cout << "(replace)" << endl;
  list<node>X_1;
  list<node>X_2;
  X_1.clear();
  X_2.clear();

  //X_1:S$B"@(B{X$B"A(BC)
  node_array<int> n1(G,0);
  node w;
  forall(w,T[v])
    n1[w]=1;

  //L:C in C_G(N_H[i])
  forall(w,L)
    if(n1[w] == 1)
      n1[w] = 2;

  forall(w,S)
    X_1.append(w);
  forall_nodes(w,G)
    if(n1[w] == 2 && X_1.search(w)==nil)
      X_1.append(w);


  //X_2:X$B"A(B{G-C)
  node_array<int> n2(G,1);
  forall(w,L)
    n2[w] = 0;
  forall(w,T[v])
    if(n2[w]==1)
      X_2.append(w);

   cout << "(8) list X_1 " ;   /*check*/
   X_1.print(cout, '\n');  /*check*/
   cout << endl;  /*check*/
   cout << "(8) list X_2 " ;   /*check*/
   X_2.print(cout, '\n');  /*check*/
   cout << endl;  /*check*/


  list<node> kl;
  kl.clear();
  if(U_A.size() > 1)
    f_edge(T,kl,v);
  else
    if(U_A.size() == 1){
      kl = U_A.head();
       cout << "(8)-0 list kl " ;   /*check*/
       kl.print(cout, '\n');  /*check*/
       cout << endl;  /*check*/
    }
  node m;
  int count =0;
  if(kl.size() != 0)
    forall(m,kl){
      if(X_1.search(m) != nil)
	count++;
    }

   cout << "(8)-1 list kl " ;   /*check*/
   kl.print(cout, '\n');  /*check*/
   cout << endl;  /*check*/

   cout << "(8)  int count " << endl;  /*check*/
   cout << count << endl;  /*check*/

  if(count == kl.size() ){
    cout << "(8)-1  rep(T,X_1,X_2,v)" << endl;  /*check*/
    rep(T,X_1,X_2,v);
  }else{
    cout << "(8)-2  rep(T,X_2,X_1,v)" << endl;  /*check*/
    rep(T,X_2,X_1,v);
  }
}

void rep(GRAPH<list<node>,int> &T,list<node> &X_1,list<node> &X_2,node v)
{
   cout << "(rep)" << endl;
  T[v].clear();
  node w1;
  forall(w1,X_1)
    T[v].append(w1);
  
  node v1 = T.new_node();
  T[v1].clear();
  node w2;
  forall(w2,X_2)
    T[v1].append(w2);
  
  edge e = T.new_edge(v,v1);
}

void f_edge(GRAPH<list<node>,int> &T,list<node> &kl,node v)
{
   cout << "(f_edge)" << endl;
  list_item it = U_A.first();
  node w;
  while(it != nil){
    int count = 0;
    forall(w,U_A[it])
      if(T[v].search(w) != nil)
	count++;
    if(count == U_A[it].size() ){
      cout << "(10)  int count " << endl;  /*check*/
      cout << count << endl;  /*check*/
      kl = U_A[it];
      return ;
    }
    it = U_A.succ(it);
  }
}
